package models

import (
	_ "github.com/go-sql-driver/mysql"
	"hongze/hongze_task/models/company_approval"
	"hongze/hongze_task/models/company_contract"
	"hongze/hongze_task/models/data_manage"
	"hongze/hongze_task/models/yb"
	"hongze/hongze_task/utils"
	"time"

	"github.com/rdlucklib/rdluck_tools/orm"
)

func init() {

	_ = orm.RegisterDataBase("default", "mysql", utils.MYSQL_URL)
	orm.SetMaxIdleConns("default", 50)
	orm.SetMaxOpenConns("default", 100)

	db, _ := orm.GetDB("default")
	db.SetConnMaxLifetime(10 * time.Minute)

	_ = orm.RegisterDataBase("rddp", "mysql", utils.MYSQL_URL_RDDP)
	orm.SetMaxIdleConns("rddp", 50)
	orm.SetMaxOpenConns("rddp", 100)

	report_db, _ := orm.GetDB("rddp")
	report_db.SetConnMaxLifetime(10 * time.Minute)

	_ = orm.RegisterDataBase("edb", "mysql", utils.MYSQL_URL_EDB)
	orm.SetMaxIdleConns("edb", 50)
	orm.SetMaxOpenConns("edb", 100)

	edb_db, _ := orm.GetDB("edb")
	edb_db.SetConnMaxLifetime(10 * time.Minute)

	_ = orm.RegisterDataBase("data", "mysql", utils.MYSQL_URL_DATA)
	orm.SetMaxIdleConns("data", 50)
	orm.SetMaxOpenConns("data", 100)

	data_db, _ := orm.GetDB("data")
	data_db.SetConnMaxLifetime(10 * time.Minute)

	_ = orm.RegisterDataBase("gl", "mysql", utils.MYSQL_URL_GL)
	orm.SetMaxIdleConns("gl", 50)
	orm.SetMaxOpenConns("gl", 100)

	gl, _ := orm.GetDB("gl")
	gl.SetConnMaxLifetime(10 * time.Minute)

	//注册对象
	orm.RegisterModel(
		new(EdbinfoSendMsgRecord),
		new(Company),
		new(CompanyReportPermission),
		new(CompanyReportPermissionLog),
		new(DataSourceLongzhong),
		new(Longzhonginfo),
		new(Longzhongdata),
		new(EdbdataClassify),
		new(Longzhongpriceinfo),
		new(Longzhongpricedata),
		new(CompanyOperationRecord),
		new(CompanyProduct),
		new(StackCompanyStatistic),
		new(CompanyPermissionLog),
		new(company_contract.CompanyContract),
		new(company_contract.CompanyContractPermission),
		new(company_approval.CompanyApproval),
		new(data_manage.EdbDataWind),
		new(data_manage.EdbDataThs),
		new(data_manage.EdbDataPb),
		new(LongzhongSurveyProduct),
		new(LongzhongSurveyData),
		new(Classify),
		new(ReportSendThsDetail),
		new(Report),
		new(CompanyEndDate),
		new(data_manage.BaseFromSmm),
		new(data_manage.BaseFromSmmIndex),
		new(data_manage.BaseFromSmmData),
		new(data_manage.EdbDataYs),
		new(Edbdata),
		new(data_manage.EdbInfoCalculateMapping),
		new(UserViewStatistics),
		new(data_manage.EdbInfo),                 //hz_data库的edb_info表
		new(data_manage.EdbDataCalculateZjpj),    //直接拼接
		new(data_manage.EdbDataCalculateLjztbpj), //累计同比值拼接
		new(yb.Activity),                         // 研报活动表
		new(yb.ActivityType),                     //研报活动分类表
		new(yb.ActivityVoice),                    //研报活动语音表
		new(yb.ActivityRegister),                 //研报活动报名表
		new(yb.Speaker),                          //研报主持人表
		new(data_manage.EdbDataLt),               //路透指标数据表
		new(CompanyProductUpdateLog),             //客户产品状态变更表
	)
}
